unit mainu; // nzev jednotky
{
 Toto je jednotka mainu.
 Je to hlavni jednotka projektu a programu klient.
 Zajiuje vechny dlet a podstatn funkce, kter
 nezajiuje dn jin jednotka ani hlavn st programu.
}

interface // deklarace rozhran

uses // pouit jednotky
  Windows, // obsahuje funkce spojen s prac s okny
  Messages, // obsahuje funkce na prci se zprvami
  SysUtils, // obsahuje systmov nstroje a podobn funkce
  Variants, // obsahuje deklarace pro prci s varianty
  Classes,  // obsahuje zkladn kd pro prci se standardnmi tdami
  Graphics, // obsahuje funkce a procedury pro prci s grafikou
  Controls, // obsahuje deklarace komponent pro spoluprci s uivatelem.
  Forms, // obsahuje deklarace zkladnch formulovch typ a souvisejcch procedur a funkc
  Dialogs, // obsahuje procedury, funkce a dal, co se tk mench dialogovch oken
  StdCtrls, // obsahuje deklarace standardnch kontrolnch prvk a komponent
  ExtCtrls, // obsahuje deklarace dalch kontrolnch prvk a komponent
  ScktComp, ComCtrls, XPMan; // obsahuje deklarace pro prci se sokety.

type // deklarace datovch typ
  TmainForm = class(TForm) // deklarace hlavnho formule
    TheSocket: TClientSocket; // socket, kterm se to sna pipojit
    lblAdresa: TLabel; // Popisek u polka s adresou
    lblPort: TLabel;  // Popisek u polka s nastavenm portu
    edtAdresa: TEdit; // Editan polko na nastaven adresy
    edtPort: TEdit; // Editan polko na nastaven portu
    Timer: TTimer; // asova pro ten ze serveru
    btnConnect: TButton; // Tlatko na pipojen
    btnDisconnect: TButton; // Tlatko na odpojen
    lblPocVytahu: TLabel; // Popisek u polka s potem vtah
    lblPocPater: TLabel; // Popisek u polka s potem pater
    edtVytahu: TEdit; // Editan polko s potem vtah
    edtPater: TEdit; // Editan polko s potem pater
    memo: TMemo;  // memo komponenta pro zapisovn LOG informac
    Image: TImage;  // Textura jako prvek uivatelsk pvtivosti
    ProgressBar: TProgressBar; // Ukazatel prbhu operac
    btnEnd: TButton;  // Tlatko na ukonen programu
    Animate: TAnimate; // Animace jako soust uivatelsk pvtivosti
    procedure btnConnectClick(Sender: TObject); // Procedura na pipojen k serveru
    procedure btnDisconnectClick(Sender: TObject); // Procedura na odpojen od serveru
    procedure FormShow(Sender: TObject);  // Inicializan procedura
    procedure Kontrola(Sender: TObject);  // Procedura na kontrolu, co se dje
    procedure btnEndClick(Sender: TObject); // Procedura na ukonen programu
  private
    { Private declarations }
    procedure Vytahy; // Procedura na uren potu vtah a pater
  public
    { Public declarations }
      // dn zde nejsou
  end; { Zde kon deklarace datovho typu TmainForm}

var // deklarace promnnch a objekt
  mainForm: TmainForm; // hlavn formul

implementation // zatek implementan sekce

{$R *.dfm} // direktiva

procedure TmainForm.btnConnectClick(Sender: TObject);
  // implementace procedury btnConnectClick z typu TmainForm
begin
{
 Tato funkce m za svj el pokusit se pipojit k serveru,
 jestli se j to nepovede, oznm to uivateli. V ppad,
 e se j to povede, spust systm, kter bude ze serveru
 st poadavky a bude na n odpovdat.
}
     memo.Lines.Add('Pipojuje se...'); // Oznm uivateli, e jeho poadavek
                                        // na pipojen nebyl ignorovn
     ProgressBar.Position := 50;
      {
       Nastav ProgressBar do pozice, kter svd o tom,
       e program nco dl.
      }
     try // pouit bloku try ... except ... end
     TheSocket.Socket.Open(TheSocket.Name,edtAdresa.Text,
          TheSocket.Service,StrToInt(edtPort.Text),True); // pod socket o pipojen
     except
      on Ex: ESocketError
       do  { zru vjimku };
     end;

     if (TheSocket.Socket.Connected) // zjist, jest-li pipojen probhlo spn
     then
      begin // v ppad, e ano...
          edtAdresa.Enabled := False; // Vypne edt. polko s nastavenm adresy
          edtPort.Enabled := False;  // Vypne edt. polko s nastavenm portu
          btnConnect.Enabled := False; // Vypne tlatko pipojen
          btnDisconnect.Enabled := True; // Zapne tlako odpojen (umon uivateli
                                          // ho stisknout)
          memo.Lines.Add('Ven uivateli, pipojen probhlo.');
          Vytahy; // zjist poet pater a vtah
          Timer.Enabled := True; // spust astova na obsluhu signl ze serveru
          ProgressBar.Position := 100; // nastav ProgressBar jako cel (hodonota 100)
      end
     else
      begin // v ppad, e se to nepovede...
         memo.Lines.Add('Mon dolo k chyb - program nen schopen se pipojit.');
          // Oznm uivateli, e mon dolo k chyb
          // a v dsledku toho se program nedoke pipojit.
         ProgressBar.Position := 99; // nastav ProgressBar.Position na hodnotu 99
      end;
end;

procedure TmainForm.btnDisconnectClick(Sender: TObject);
  // implementace procedury btnDisconnectClick z typu TmainForm
begin
{
 Tato funkce m za svj el odpojit program od serveru.
}
     Timer.Enabled := False; // vypne asova zajiujc obsluhu serveru
     btnDisconnect.Enabled := False; // vypne tlatko Odpojit
     btnConnect.Enabled := True; // zapne tlatko Pipojit
     edtPort.Enabled := True; // Zapne editan polko s nastavenm portu
     edtAdresa.Enabled := True; // Zapne editan polko s nastavenm adresy
     TheSocket.Socket.Close; // Uzave pipojen
     memo.Lines.Add('Ven uivateli, dolo k odpojen.'); // oznm uivateli, e k odpojen
                  // na zklad jeho poadavku dolo.
end;

procedure TmainForm.FormShow(Sender: TObject);
  // implementace procedury FormShow z typu TmainForm
begin
{
 elem tto inicializan funkce je uvtat uivatele
 a sdlit mu, jak je el programu, kter spustil
 (tohoto programu). Sm by to toti uivatel nemusel poznat.
}
     MessageDlg( { Zobraz dialogov okno s uvtac zprvou pro uivatele }
 'Ven uivatel, prv jste spustili program, kter m slouit jako klient k vtahu.',
mtWarning,[mbYes, mbNo, mbOK, mbCancel, mbAbort, mbRetry, mbIgnore, mbAll, mbNoToAll, mbYesToAll, mbHelp],0);
 // Aby byl uivatel zcela svobodn, dostane na vbr
 // vechny druhy tlatek, aby si mohl vybrat, kter
 // z nich mu nejvce vyhovuje.
 Animate.Play(Animate.StartFrame,Animate.StopFrame,999); // spust animaci
end;

procedure TmainForm.Vytahy;
 // implementace procedury Vytahy z typu TmainForm
begin
     {
      Tato funkce by mla zjistit poet vtah a pater, ale
      v tto verzi to bohuel jt neum.
     }
     ShowMessage('Spustila se procedura na urovn potu pater a vtah, ale je pli neschopn na to, aby to dokzala.');
end;

procedure TmainForm.Kontrola(Sender: TObject);
 // implementace procedury Kontrola z typu TmainForm
begin
     {
      Tato funkce by mla, spoutna pravideln asovaem Timer, kontrolovat,
      jestli sever nevyaduje njakou reakci, ale v tto verzi to zatm neum.
     }
     ShowMessage('Byla sputna procedura TmainForm.Kontrola. Jest-li nevte, co dl, podvejte se do zdrojovho kdu. Je to tam dobe okomentovan.');
end;

procedure TmainForm.btnEndClick(Sender: TObject);
  // implementace procedury btnEndClick z typu TmainForm
begin
     {
      elem tto funkce je obslouit stisknut tlatka Konec
      tak, e bude program ukonen uzavenm hlavnho okna.
     }
     mainForm.Close; // uzave hlavn okno a ukon program.
end;

end. // zde kon tato jednotka
